package servletsocket;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import javax.swing.*;

public class AppletInversion extends JApplet {
  private boolean isStandalone = false;
  JPanel panneau = new JPanel();
  JTextField saisie = new JTextField();
  JButton envoyer = new JButton();
  JLabel message = new JLabel();

  //Obtenir une valeur de paramtre
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construire l'applet
  public AppletInversion() {
  }

  //Initialiser l'applet
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Initialiser le composant
  private void jbInit() throws Exception {
    this.getContentPane().setBackground(Color.orange);
    this.setSize(new Dimension(270,150));
    panneau.setBackground(Color.blue);
    saisie.setText("Bienvenue !");
    saisie.setColumns(15);
    envoyer.setText("Envoyer");
    envoyer.addActionListener(new AppletInversion_envoyer_actionAdapter(this));
    message.setFont(new java.awt.Font("Dialog", 3, 24));
    message.setForeground(Color.red);
    message.setHorizontalAlignment(SwingConstants.CENTER);
    message.setText("Bienvenue !");
    this.getContentPane().add(panneau, BorderLayout.SOUTH);
    panneau.add(saisie, null);
    panneau.add(envoyer, null);
    this.getContentPane().add(message, BorderLayout.CENTER);
  }

  //Obtenir les informations d'applet
  public String getAppletInfo() {
    return "Information applet";
  }

  //Obtenir les informations de paramtre
  public String[][] getParameterInfo() {
    return null;
  }

  //Initialiseur statique pour le paramtre LookAndFeel
  static {
    try {
      //UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
    }
    catch(Exception e) {
    }
  }

  void envoyer_actionPerformed(ActionEvent e) {
    try {
      URL urlServlet = new URL(getDocumentBase(), "ServletSocket");
      URLConnection connexion = urlServlet.openConnection();
      connexion.setDoOutput(true);

      ObjectOutputStream requte = new ObjectOutputStream(connexion.getOutputStream());
      requte.writeObject(new Transmission(1234, saisie.getText(), true));

      ObjectInputStream rponse = new ObjectInputStream(connexion.getInputStream());
      Transmission transmission = (Transmission) rponse.readObject();

      if (transmission.isOk()) message.setText(transmission.getMessage());
      else saisie.setText(transmission.getMessage());
    }
    catch (IOException erreur) { message.setText("Erreur communication servlet"); }
    catch (ClassNotFoundException erreur) { message.setText("Objet non transmis"); }
  }
}

class AppletInversion_envoyer_actionAdapter implements java.awt.event.ActionListener {
  AppletInversion adaptee;

  AppletInversion_envoyer_actionAdapter(AppletInversion adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.envoyer_actionPerformed(e);
  }
}
